/* This file contains the structures for Adaptive Mesh Refinement (AMR)
   for the finite difference code. 

                     Updated 3/17/07

    SLFCFD source file
    Version:  1.2
    Copyright (C) 2007  San Le

    The source code contained in this file is released under the
    terms of the GNU Library General Public License.

*/

#include <stddef.h>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "../compressible/cfdconst.h"

typedef struct {
	int i, j, k;
	int ijk;
	int flag;
} SUBNODE;

/* This structure is mostly for defining the nodes which make up the region
   to be refined.
*/

typedef struct {
	int istart, jstart, kstart, iend, jend, kend;
	double xstart, ystart, zstart, xend, yend, zend;
	double dx, dy, dz, dt;
	int nx, ny, nz;
	int bc_type;
	int refine_num;
	int parent_id;
	int num_children;
	int stop_flag;
} SUBGRID;


