/* This program applies the boundary conditions when the conjugate
   gradient method is used.  Thi boundary conditions are applied on the
   border of the mesh.  This is for a finite difference program.

                        Updated 3/24/07 

    SLFCFD source file
    Version:  1.2
    Copyright (C) 2007  San Le

    The source code contained in this file is released under the
    terms of the GNU Library General Public License.
 */

#include <stddef.h>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "amr.h"

int Perimeter_Boundary ( double *vec_dum, SUBGRID subgrid_f )
{
	int i, j, node_num, dum, nx_f, ny_f;

	nx_f = subgrid_f.nx;
	ny_f = subgrid_f.ny;

	for( i = 0; i < nx_f; ++i)
	{
		j = 0;
		node_num = i + nx_f*j;
		vec_dum[node_num] = 0.0;
		j = ny_f - 1;
		node_num = i + nx_f*j;
		vec_dum[node_num] = 0.0;
	}

	for( j = 0; j < ny_f; ++j)
	{
		i = 0;
		node_num = i + nx_f*j;
		vec_dum[node_num] = 0.0;
		i = nx_f - 1;
		node_num = i + nx_f*j;
		vec_dum[node_num] = 0.0;
	}

	return 1;
}

int Coarse_Boundary ( double *vec_dum, SUBGRID subgrid_c , SUBGRID subgrid_f )
{
	int i, j, node_num, dum, nx_c, ny_c;
	int istart, iend, jstart, jend;

	nx_c = subgrid_c.nx;
	ny_c = subgrid_c.ny;

	istart = subgrid_f.istart;
	iend = subgrid_f.iend;
	jstart = subgrid_f.jstart;
	jend = subgrid_f.jend;

	for( i = istart + 1; i < iend; ++i)
	{
	    for( j = jstart + 1; j < jend; ++j)
	    {
		j = 0;
		node_num = i + nx_c*j;
		vec_dum[node_num] = 0.0;
		j = ny_c - 1;
		node_num = i + nx_c*j;
		vec_dum[node_num] = 0.0;
	    }
	}

	return 1;
}
