/*
    This utility function allocates the memory for the finite
    difference mesh graphics program. 

	Updated 2/29/08

    SLFCFD source file
    Version:  1.2
    Copyright (C) 2006, 2007, 2008  San Le

    The source code contained in this file is released under the
    terms of the GNU Library General Public License.

*/

#include <stdlib.h>
#include <string.h>
#include "fdstrcgr.h"
#include "../compressible/cfdconst.h"
#include "../compressible/cfdstruct.h"

extern int input_flag, post_flag;

int fdMemory_gr( I_GR_NODE **node_color, int sofmI_GR_NODE, NORM **mem_NORM, int sofmNORM )
{
/* Allocate the memory for when first running the program

	Updated 2/29/08

*/

/* For the I_GR_NODE integers */

	*node_color=(I_GR_NODE *)calloc(sofmI_GR_NODE,sizeof(I_GR_NODE));
	if(!node_color )
	{
		printf( "failed to allocate memory for node integers\n ");
		exit(1);
	}


/* For the NORM doubles */

	*mem_NORM=(NORM *)calloc(sofmNORM, sizeof(NORM));
	if(!mem_NORM )
	{
		printf( "failed to allocate memory for NORM doubles\n ");
		exit(1);
	}

	return 1; 
}

int fdReGetMemory_gr( I_GR_NODE **node_color, int sofmI_GR_NODE, NORM **mem_NORM, int sofmNORM )
{
/* Re-Allocate the memory for new input file 

	Updated 2/29/08

*/

/* For the I_GR_NODE integers */

	*node_color=(I_GR_NODE *)realloc(*node_color, sofmI_GR_NODE*sizeof(I_GR_NODE));
	if(!node_color )
	{
		printf( "failed to allocate memory for node integers\n ");
		exit(1);
	}
	memset(*node_color,0,sofmI_GR_NODE*sizeof(I_GR_NODE));

/* For the NORM doubles */

	*mem_NORM=(NORM *)realloc(*mem_NORM, sofmNORM*sizeof(NORM));
	if(!mem_NORM )
	{
		printf( "failed to allocate memory for NORM doubles\n ");
		exit(1);
	}
	memset(*mem_NORM,0,sofmNORM*sizeof(NORM));

	return 1; 
}

