/* This progam uses system calls to compile targa images
   ".tga" into mpeg ".mpg" animations using ffmpeg.  It also
   deletes all the *.tga files after compiling an animation.

   This program compiles only 10 frames at a time from 
   the output of sciencific data.  After they are compiled
   into animation by this program, those frames are deleted
   and the next set are generated.

    Updated 7/1/08

 */

#include <stddef.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h> 

int main()
{
	FILE *o1, *o2, *o3;
	int i, j, dum, dum2, check, flag, cstep, nstep, nstepdiv10, counter, counter2;
	double fdum, fdum2, fdum3;
	char name[20], name2[20], command_txt[30], buf[ BUFSIZ ];
	char *ccheck;

	o3 = fopen( "cfdmovie.mpg", "r");
	if(o3 != NULL)
	{
	    check = system( "rm cfdmovie.mpg");
	    fclose(o3);
	}

	o2 = fopen( "anim_name", "r");
	if(o2 == NULL)
	{
	    printf( "\n Can't find anim_name\n\n");
	    exit(1);
	}
	else
	{
	    fgets( buf, BUFSIZ, o2 );
	    fgets( buf, BUFSIZ, o2 );
	    fgets( buf, BUFSIZ, o2 );
	    fgets( buf, BUFSIZ, o2 );
	    fgets( buf, BUFSIZ, o2 );
	    fscanf( o2, "%lf %d %d %lf %lf", &fdum, &nstep, &cstep, &fdum2, &fdum3 );
	    printf( "\n  nstep: %d cstep: %d\n\n", nstep, cstep);
	    fclose(o2);
	}

	dum = nstep%10;
	    printf( "%d\n", dum );
	dum = nstep - dum;
	    printf( "%d\n", dum );
	nstepdiv10 = (int)(dum/10);
	    printf( "%d\n", nstepdiv10 );
	
	memset( command_txt, 0, 30*sizeof(char));
	memset( name, 0, 20*sizeof(char));


	counter = cstep;
	for( j = 0; j < nstepdiv10; ++j )
	{
	    ccheck = strncpy( name, "pic0", 4);
	    for( i = 0; i < 10; ++i )
	    {
		sprintf( name+4, "%1d", i);
		ccheck = strncpy( name + 5, ".tga", 4);

		printf( "Working on frame: %s\n", name);
		printf( "The current step is %5d\n", counter);

/* Check for the existence of file pic*.tga and wait while it
   is generated.
*/
		flag = 1;
		counter2 = 0;
		while(flag)
		{
		    flag = 0;
		    o1 = fopen( name, "r");
		    if(o1 == NULL)
		    {
			flag = 1;
			sleep(3);
			printf( " waiting %s\n", name);
		    }
		    ++counter2;
		    if(counter2 > 10) flag = 0;
		}
		if(counter2 < 10 ) fclose(o1);

		++counter;
		if( counter > nstep )
		{
		    o3 = fopen( "cfdmovie.mpg", "r");
		    if(o3 == NULL) check = system( "mv temp2.mpg cfdmovie.mpg");
		    else fclose(o3);
		    exit(1);
		}
	    }

	    check = system( "ffmpeg -i pic0%d.tga temp.mpg");

/* The loop below deletes these files once they have been compiled into
   animations.  Note that only after they are deleted can ffanim.c
   or ffanim.c start generating new images.
*/

	    check = system( "rm pic00.tga");
	    check = system( "rm pic01.tga");
	    check = system( "rm pic02.tga");
	    check = system( "rm pic03.tga");
	    check = system( "rm pic04.tga");
	    check = system( "rm pic05.tga");
	    check = system( "rm pic06.tga");
	    check = system( "rm pic07.tga");
	    check = system( "rm pic08.tga");
	    check = system( "rm pic09.tga");

	    if( j == 0 )
	    {
		check = system( "mv temp.mpg temp2.mpg");
	    }
	    else
	    {
		check = system( "cat temp2.mpg temp.mpg > cfdmovie.mpg");
		check = system( "mv cfdmovie.mpg temp2.mpg");
		check = system( "rm temp.mpg");
	    }

	}



	dum = nstep%10;
	if(!dum) check = system( "mv temp2.mpg cfdmovie.mpg");
	
/* If the number of steps is a multiple of 10, then don't compile any more
   frames.
*/
	if(dum)
	{
	    ccheck     = strncpy( name, "pic0", 4);
	    for( i = 0; i < nstep - nstepdiv10*10; ++i )
	    {
		sprintf( name+4, "%1d", i);
		ccheck = strncpy( name + 5, ".tga", 4);

		if(i > 9 )
		{
		    sprintf((name+3), "%2d", i);
		    ccheck = strncpy( name + 5, ".tga", 4);
		}

		printf( "Working on frame: %s\n", name);
		printf( "The current step is %5d\n", counter);


/* Check for the existence of file pic*.tga and wait while it
   is generated.
*/
		flag = 1;
		while(flag)
		{
		    flag = 0;
		    o1 = fopen( name, "r");
		    if(o1 == NULL)
		    {
			flag = 1;
			sleep(3);
		    }
		}
		fclose(o1);
		++counter;
	    }

	    check = system( "ffmpeg -i pic0%d.tga temp.mpg");

/* The loop below deletes these files once they have been compiled into
   animations.  These are the last set of images so ffanim.c
   or ffanim.c should be finished running.
*/

	    for( i = 0; i < nstep - nstepdiv10*10; ++i )
	    {
		ccheck = strncpy( command_txt, "rm pic0", 7);
		sprintf( command_txt + 7, "%1d", i);
		ccheck = strncpy( command_txt + 8, ".tga", 4);

		printf( "%s\n", command_txt);
		check = system( command_txt );
	    }

	    if( nstepdiv10 > 0 )
	    {
		check = system( "cat temp2.mpg temp.mpg > cfdmovie.mpg");
		check = system( "rm temp2.mpg");
	    }
	    else check = system( "cp temp.mpg cfdmovie.mpg");
	    check = system( "rm temp.mpg");
	}


	return 1;
}	

