/* This program determines the options passed through the command
   line.  The options are:

 -p   print data as it is read in.
 -i   give input file:  Must use with -i (filename)
 -a   animate data:
 -s   save animation data:

                        Last Update 7/1/08

    SLFCFD source file
    Version:  1.2
    Copyright (C) 2008  San Le

    The source code contained in this file is released under the
    terms of the GNU Library General Public License.
*/


#include <stddef.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "../compressible/cfdstruct.h"

extern int print_flag;

int parse_options( int argc, char **argv, ANIM_DAT *anim, char *name, int codetype_flag )
{

	int i, j, k;
	int check, name_length, counter, argv_flag = 0, name_flag = 0;
	char *ccheck;
     
	if(argc > 1)
	{
	    name_flag = 0;
	    counter = 0;  /* counter will equal total number of options <= 3 */
	    for( i = 1; i < 6; ++i )
	    {
		if( argv[i] != NULL )
		{
		    if( !strncmp(argv[i], "-i", 2))
		    {
			name_flag = i+1;
			if( argv[i+1] == NULL )
			{
/* If "-i" flag is given, then we expect an input file to follow. Exit
   when this is not the case. */

			    printf("usage is -p, -a, or -i (filename)\n");
			    exit(1);
			}
		    }
		    counter += 1;
		}
		else break;
	    }

	    print_flag = 0;
	    anim[0].flag = 0;
	    if( name_flag )
	    {
		name_length = strlen(argv[name_flag]);
		if( name_length > 25) name_length = 25;
		ccheck = strncpy( name, argv[name_flag], name_length);
		for( i = 1; i <= counter; ++i )
		{
		    argv_flag = 0;
		    if( i != name_flag && i != name_flag - 1 )
		    {
			if( !strncmp(argv[i], "-p", 2))
			{
			    print_flag = 1;
			    argv_flag = 1;
			}
			if( !strncmp(argv[i], "-a", 2))
			{
			    anim[0].flag = 1;
			    argv_flag = 1;
			}
			if( !argv_flag)
			{
			    printf("usage is -p, -a, or -i (filename)\n");
			    exit(1);
			}
			if(codetype_flag == 3 && anim[0].flag == 1)
			{
			    printf("When you run fdpost for animation, you should\n");
			    printf("not give an input file.  It is already taken from\n");
			    printf("the science code.\n");
			    exit(1);
			}
			if(codetype_flag == 3 && anim[0].save_flag == 1)
			{
			    printf("When you run fdpost for saving animation, you should\n");
			    printf("not give an input file.  It is already taken from\n");
			    printf("the science code.\n");
			    exit(1);
			}
		    }
		}
	    }
	    else
	    {
		for( i = 1; i <= counter; ++i )
		{
		    argv_flag = 0;
		    if( !strncmp(argv[i], "-p", 2))
		    {
			print_flag = 1;
			argv_flag = 1;
		    }
		    if( !strncmp(argv[i], "-a", 2))
		    {
/* This line below is for when an input file is expected when the animation is given. But
   is no longer a requirement.
*/
			/*printf("usage is -a -i (filename) or -i (filename) -a\n");
			exit(1);*/

			anim[0].flag = 1;
			argv_flag = 1;
		    }
		    if( !strncmp(argv[i], "-s", 2))
		    {
			if( codetype_flag == 3)
			{
			    anim[0].save_flag = 1;
			    argv_flag = 1;
			}
			else
			{
			    printf("The save flag can only be used with \"fdpost\".\n");
			    exit(1);
			}
		    }
		    if( !argv_flag)
		    {
			printf("usage is -p, -a, or -i (filename)\n");
			exit(1);
		    }
		}

		if(codetype_flag == 3 && anim[0].flag == 1) return 1;
		if(codetype_flag == 3 && anim[0].save_flag == 1) return 1;

/* Prompt for input filename only if NOT running "fdpost" with animation or saving an animation. */

		printf("What is the name of the file containing the \n");
		if(codetype_flag == 3 ) printf("finite difference CFD data?\n");
		if(codetype_flag == 2 ) printf("incompressible finite difference CFD data? (example: a0)\n");
		if(codetype_flag == 1 ) printf("compressible finite difference CFD data? (example: jet2D)\n");
		scanf( "%30s",name);
	    }

	}
	else
	{
	    printf("What is the name of the file containing the \n");
	    if(codetype_flag == 3 ) printf("finite difference CFD data?\n");
	    if(codetype_flag == 2 ) printf("incompressible finite difference CFD data? (example: a0)\n");
	    if(codetype_flag == 1 ) printf("compressible finite difference CFD data? (example: jet2D)\n");
	    scanf( "%30s",name);
	}

        return 1;
}
