/*
    This program calculates the shape functions for a quad
    element.

    SLFCFD source file
    Version:  1.2
    Copyright (C) 2008  San Le 

    The source code contained in this file is released under the
    terms of the GNU Library General Public License.
 
*/


#include <stddef.h>
#include <stdlib.h>
#include <math.h>
#include "shape_struct.h"


int cfdshape(SHAPE *sh, double xi, double eta)
{
/* Maps from global coordinates to local coordinates and
   calculates the shape functions 

            Updated 4/8/06
*/

	sh->Nhat[0].dx0 = .25*(1.0 - xi)*(1.0 - eta);
	sh->Nhat[1].dx0 = .25*(1.0 + xi)*(1.0 - eta);
	sh->Nhat[2].dx0 = .25*(1.0 + xi)*(1.0 + eta);
	sh->Nhat[3].dx0 = .25*(1.0 - xi)*(1.0 + eta);

	return 1;
}


