/* This program resets the variables after the corrector step for the program which
   uses the finite difference method to calculate a compressible CFD flow field.

                     Updated 12/22/05

    SLFCFD source file
    Version:  1.2
    Copyright (C) 2005, 2006, 2007, 2008  San Le

    The source code contained in this file is released under the
    terms of the GNU Library General Public License.

*/

#include <stddef.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <time.h>
#include "cfdconst.h"
#include "cfdstruct.h"

extern dof, numel, numnp, sof, nx, ny, nz;
extern int flag_2D, flag_3D;

int flwReset (COM_NODE *node)
{
	int i, j, k, dum, node_num;

	/* printf("ggggg %4d %4d %4d %4d\n", nx, ny, nz, num);*/
	for ( i=0; i < nx; i++)
	{
	    for ( j=0; j < ny; j++)
	    {
		for ( k=0; k < nz; k++)
		{
		    node_num = nz*ny*i + nz*j + k;

		    node[node_num].dns    = node[node_num].dnsC;
		    node[node_num].vx     = node[node_num].vxC;
		    node[node_num].vy     = node[node_num].vyC;
		    node[node_num].vz     = node[node_num].vzC;
		    node[node_num].ene    = node[node_num].eneC;
		    node[node_num].temp   = node[node_num].tempC;
		    node[node_num].enthal = node[node_num].enthalC;
		    node[node_num].prs    = node[node_num].prsC;
		    	   
		    node[node_num].U[0] = node[node_num].UC[0];
		    node[node_num].U[1] = node[node_num].UC[1];
		    node[node_num].U[2] = node[node_num].UC[2];
		    node[node_num].U[3] = node[node_num].UC[3];
		    node[node_num].U[4] = node[node_num].UC[4];

		    node[node_num].F[0] = node[node_num].FC[0];
		    node[node_num].F[1] = node[node_num].FC[1];
		    node[node_num].F[2] = node[node_num].FC[2];
		    node[node_num].F[3] = node[node_num].FC[3];
		    node[node_num].F[4] = node[node_num].FC[4];

		    node[node_num].G[0] = node[node_num].GC[0];
		    node[node_num].G[1] = node[node_num].GC[1];
		    node[node_num].G[2] = node[node_num].GC[2];
		    node[node_num].G[3] = node[node_num].GC[3];
		    node[node_num].G[4] = node[node_num].GC[4];

		    node[node_num].H[0] = node[node_num].HC[0];
		    node[node_num].H[1] = node[node_num].HC[1];
		    node[node_num].H[2] = node[node_num].HC[2];
		    node[node_num].H[3] = node[node_num].HC[3];
		    node[node_num].H[4] = node[node_num].HC[4];

		}
	    }
	}

	return 1;
}


