/* This program calculates the total residual mass by adding all the mass
   flowing into each control volume minus the mass out.

   This is probably not a legitimate calculation, since it probably would
   require adding the absolute values of the residual of each control volume.
   But I am leaving it here in case it would be useful for debuggin in the
   future.

                     Updated 4/7/08

    SLFCFD source file
    Version:  1.2
    Copyright (C) 2006, 2007, 2008  San Le

    The source code contained in this file is released under the
    terms of the GNU Library General Public License.

*/

#include <stddef.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <time.h>
#include "../compressible/cfdconst.h"
#include "../compressible/cfdstruct.h"
#include "../AMR/amr.h"

int MassFlow( double *mass_flow, INC_NODE *node, SUBGRID subgrid,
	double *residual)
{
	int i, j, k, dum, dum2, node_num;
	int nx, ny, istart, iend, jstart, jend;
	int ce, xm1, xp1, ym1, yp1;
	double dx, dy, dt;

	dx = subgrid.dx;
	dy = subgrid.dy;
	dt = subgrid.dt;
	nx = subgrid.nx;
	ny = subgrid.ny;

	*residual = 0.0;
	for( i = 1; i < nx; ++i )
	{
	   for( j = 1; j < ny; ++j )
	   {
		ce  = ny*i + j;
		xm1 = ny*(i-1) + j;
		xp1 = ny*(i+1) + j;
		ym1 = ny*i + (j-1);
		yp1 = ny*i + (j+1);

		mass_flow[ce] = dx*(node[ce].vxQ - node[xm1].vxQ) + dy*(node[ce].vyQ - node[ym1].vyQ);
		*residual += mass_flow[ce];

		/*printf(  "m2m2m2m2 %d %d %d %16.8e %16.8e %16.8e %16.8e %16.8e %16.8e\n",
			i, j, ce, node[ce].vx, node[xm1].vxQ, node[ce].vy, node[ym1].vyQ, mass_flow[ce], *residual);*/

	   }
	}

	printf(  "residual mass: %16.8e\n", *residual);

	return 1;
}


